function write(msg, tp) {
    var cl = $('section#chat div#content1');
    var cc = $('<div>', { class: 'chat-content' });
    switch (tp) {
        case 'join':
            cc = $('<div>', { class: 'enterychat' });
            cc.append($('<span>').html('[' + msg.nickName + ']님이 입장하셨습니다.'));
            break;
        case 'leave':
            cc = $('<div>', { class: 'logoutchat' });
            cc.append($('<span>').html('[' + msg.nickName + ']님이 나가셨습니다.'));
            break;
        case 'notice':
            cc = $('<div>', { class: 'noticechat' });
            cc.append($('<span><i class="fas fa-flag"></i></span>'));
            cc.append($('<span>').html(typeof msg == 'string' ? msg : msg.message));
            break;
        case 'whisper':
            cc = $('<div>', { class: 'whisperchat' });
            cc.append($('<span><i class="fas fa-comment-alt"></i></span>'));
            cc.append(
                $('<ul>')
                .append($('<li>').append($('<a href="#!" class="name">').html(msg.nickName).data(msg).on({ click: openLayer })).append(document.createTextNode('님의 귓속말')))
                .append($('<li class="comment">').text(msg.message))
            );
            break;
        case 'whisperto':
            cc = $('<div>', { class: 'whisperchat' });
            cc.append($('<span><i class="fas fa-comment-alt"></i></span>'));
            cc.append(
                $('<ul>')
                .append($('<li>').append($('<a href="#!" class="name">').html(msg.receivedNickName)).append(document.createTextNode('님에게 귓속말')))
                .append($('<li class="comment">').text(msg.message))
            );
            break;
        default:
            cc = $('<div>', { class: 'chat-content' });
            if (typeof msg == 'string') {
                cc.append($('<a class="name" href="#!">').text(''));
                cc.append($('<span class="comment">').html(msg));
            } else if (typeof msg == 'object' && msg.message) {
                if (channel.clientKey != msg.clientKey) {
                    cc.append($('<a class="name" href="#!">').text(msg.nickName).data(msg).on({ click: openLayer }));
                } else {
                    cc.append($('<a class="name" href="#!">').text(msg.nickName));
                }
                cc.append($('<span class="comment">').html(msg.message));
            }
    };
    cl.append(cc);
    $('section#chat div.middle').scrollTop(cl.height());
}