var vChatCloud = new VChatCloud();
var channel, userNick, userKey;
$(function() {
    var p = $('div.enterypopup').show(),
        c = $('div.chat_field').hide();
    var r = { room: $('input#room', p).val(), nick: $('input#id', p).val() };
    if (!localStorage) {
        $('a.popupbtn', p).click(function() {
            if (r.room && r.nick) {
                p.hide();
                c.show();
                $('div.bottom div.name').text(r.nick);
                joinRoom(r.room, 'userkey', r.nick);
            }
        });
    } else if ((!userNick || !userKey)) {
        if (!localStorage['userKey'])
            localStorage.setItem('userKey', 'xxxxxxxx'.replace(/[xy]/g, function(a, b) { return (b = Math.random() * 16, (a == 'y' ? b & 3 | 8 : b | 0).toString(16)) }));
        if (localStorage['roomId'])
            $('input#room', p).val(localStorage['roomId'])
        if (localStorage['userNm'])
            $('input#id', p).val(localStorage['userNm'])
        $('a.popupbtn', p).click(function() {
            if (r.room && r.nick) {
                $('div.bottom div.name').text(r.nick);
                localStorage.setItem('roomId', r.room);
                localStorage.setItem('userNm', r.nick);
                joinRoom(r.room, localStorage['userKey'], r.nick, function(err, history) {
                    if (err) {
                        openError(err.message, function() {
                            p.show();
                            c.hide();
                            vChatCloud.disconnect();
                        });
                        p.hide();
                        c.show();
                    } else {
                        // 채팅영역에 글쓰기가 활성화될시 활성화
                        if (typeof write == 'function') history && history.reverse().forEach(function(m) { write(m) });
                        p.hide();
                        c.show();

                        // 이벤트 바인딩 시작
                        chatInit()
                        personalInit()
                        msgInit()
                        likeInif()
                    }
                });
            }
        });
    }
    $('p i.closebtn').click(function() {
        p.show();
        c.hide();
        vChatCloud.disconnect();
    })
})

function joinRoom(roomId, clientKey, nickName, callback) {
    // vchatcloud 객체
    channel = vChatCloud.joinChannel({
        roomId: roomId,
        clientKey: clientKey,
        nickName: nickName
    }, function(error, history) {
        $('section#chat div#content1 div.chat-content,div.noticechat').remove()
        if (error) {
            if (callback) return callback(error, null);
            return error;
        }
        if (callback) callback(null, history);
        // 채팅영역에 글쓰기가 활성화될시 활성화
        if (typeof write == 'function') write("실시간 채팅에 오신 것을 환영합니다. 개인정보를 보호하고 커뮤니티 가이드를 준수하는 것을 잊지 마세요!.", 'notice');
    })
}

function openError(msg, callback) {
    var p = $('div.errorpopup').hide();
    $('p:nth-child(2)', p).text(msg);
    $('a', p).off().click(function() { p.hide(); if (typeof callback == 'function') { callback() } });
    p.show();
}

function openLayer(e) {
    var sWidth = window.innerWidth;
    var sHeight = window.innerHeight;
    var oWidth = $('.popupLayer').width();
    var oHeight = $('.popupLayer').height();
    var fWidth = $("#chat").offset().left;
    var fHeight = $("#chat").offset().top;
    var cHeight = $("#content1").height();
    // 레이어가 나타날 위치를 셋팅한다.
    var divLeft = e.clientX - fWidth;
    var divTop = e.clientY - fHeight;
    // 레이어가 화면 크기를 벗어나면 위치를 바꾸어 배치한다.
    if (divLeft + oWidth > sWidth) divLeft -= oWidth;
    if (divTop + oHeight > sHeight) divTop -= oHeight;
    if (divTop > (cHeight - oHeight)) {
        divTop = divTop - oHeight;
    }
    $('.popupLayer').data($(this).data()).css({
        "top": Math.max(0, divTop),
        "left": Math.max(0, divLeft),
        "position": "absolute",
        "z-index": 1
    }).show();
    $("#whisper").show();
}